/* -*- Mode: C; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

#ifndef NMN_ETHERNET_HANDLER_H
#define NMN_ETHERNET_HANDLER_H

#include <glib-object.h>
#include <nm-device-ethernet.h>
#include "nmn-device-handler.h"

#define NMN_TYPE_ETHERNET_HANDLER            (nmn_ethernet_handler_get_type ())
#define NMN_ETHERNET_HANDLER(obj)            (G_TYPE_CHECK_INSTANCE_CAST ((obj), NMN_TYPE_ETHERNET_HANDLER, NmnEthernetHandler))
#define NMN_ETHERNET_HANDLER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST ((klass), NMN_TYPE_ETHERNET_HANDLER, NmnEthernetHandlerClass))
#define NMN_IS_ETHERNET_HANDLER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE ((obj), NMN_TYPE_ETHERNET_HANDLER))
#define NMN_IS_ETHERNET_HANDLER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((obj), NMN_TYPE_ETHERNET_HANDLER))
#define NMN_ETHERNET_HANDLER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), NMN_TYPE_ETHERNET_HANDLER, NmnEthernetHandlerClass))

typedef struct {
    NmnDeviceHandler parent;
} NmnEthernetHandler;

typedef struct {
    NmnDeviceHandlerClass parent;
} NmnEthernetHandlerClass;

GType nmn_ethernet_handler_get_type (void);

NmnDeviceHandler *nmn_ethernet_handler_new (NmnNMData *nm_data,
                                            NMDeviceEthernet *device);

#endif /* NMN_ETHERNET_HANDLER_H */
